package com.tscsdk;


import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import java.io.File;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import com.example.ptxsdk.*;



import com.sun.jna.Library;
import com.sun.jna.Native;
public class JavaTest 
{


	public interface PTXLIBDLL extends Library
	{		
		String[] a = new String[2];
		PTXLIBDLL INSTANCE = (PTXLIBDLL) Native.loadLibrary("\\PTXLIB", PTXLIBDLL.class);
        int about ();
        String PTXA_GetStatus();
        int PTXA_SetupStatus(int mode);
        int openport (String printname);
        int openethernet(String ip ,int port);
        int PTXA_DLLinit();
        int closeport (int delay);
        int sendcommand(String cmd);
        int PTXA_VerifyRFID(int lform,String UNLOCK, String membank, int length, String format);
        String PTXA_Read(String condition);
        int PTXA_CreateForm(String name);
        int PTXA_FontSetup(int mode,String value);
        int PTXA_PrintTextCH(int iform, int sr, int sc, int ve, int he, String data);
        int PTXA_PrintForm(int ForNum);
        int sendcommandutf8(String cmd);
        int sendBinaryData (byte[] printerCommand, int CommandLength);
        int closeport();
        int PTXA_DownloadPCX(String filename, String logoname);
        int PTXA_PrintImage(int lForm, int SR, int SC, String logoname);
        int PTXA_JobSetup(int mode, int value);
        int PTXA_Scale(int hdpi, int vdpi);
        }
	public static void main(String[] args)
    {
		JavaTest demo = new JavaTest();
		String RFID_format = "H";
		String formName = "formName";
		//打印文字及条码
		PTXLIBDLL.INSTANCE.openport("USB");//使用USB口打印
		//PTXLIBDLL.INSTANCE.openethernet("10.100.33.107",9100);//使用网口打印，打印PORT默认为9100，可在打印机内修改
		//PTXLIBDLL.INSTANCE.PTXA_DownloadPCX("UL.PCX", "UL");//下载UL.PCX至打印机，此项下载需在createform之前
		demo.createform();//创建一个表单
		demo.setbolden(true);//使用内部字体打印时，可以选择是否加粗，单独下载的自由字体此功能无效
		//demo.printtext("100","30","10","10","简体中文测试test ");//使用中文字体进行打印，可选配字库卡
		demo.printtexten("100","60","10","10","boldprinttest");//使用内部字体打印英文
		//String cmd2="RFWTAG;96;EPC\n96;H;*50300011217017ABC1058100*\nSTOP\n";//向EPC内写入数据指令，其中的96参数为写入数据长度*4
		//PTXLIBDLL.INSTANCE.sendcommand(cmd2);//将EPC写入指令发送至打印机，其余PGL指令均可有sendcommand方法发送至打印机内使用
		demo.printcode128("100", "60", 2, "barcodetest", true,5.14);//打印code128一维码，high高度单位为0.1英寸，包含码文是最小为4，不包含码文是最小为3，最大99
		demo.printqrcode("100","200","5","QRCODETEST");//打印QRCODE二维码
		//PTXLIBDLL.INSTANCE.sendcommand("LOGO\r\n8;8;UL\r\nSTOP\r\n")将UL.PCX图片打印出来
		demo.printform();//打印此表单
		PTXLIBDLL.INSTANCE.closeport();		
    }
	public void createform()
	{
		String cmd = "~CREATE;formName;X\r\nSCALE;DOT;203;203\r\nFONT;SYMSET 'UTF8'\r\n";//创建表单，分辨率为203，如是300点机器，请改为300;300
		PTXLIBDLL.INSTANCE.sendcommand(cmd);
	}
	public void setbolden(boolean bold)
	{
		if(bold)
		{
			String cmd = "FONT;NAME 92244.sf;BOLD 1\r\n";//使用字体为92244.sf，可在打印机内确认查看
			PTXLIBDLL.INSTANCE.sendcommand(cmd);
		}
		else
		{
			String cmd = "FONT;NAME 92244.sf;BOLD 0\r\n";
			PTXLIBDLL.INSTANCE.sendcommand(cmd);
		}
		
	}
	public void printform()
	{
		String cmd = "END\r\n~EXECUTE;formName\r\n~NORMAL\r\n";
		PTXLIBDLL.INSTANCE.sendcommand(cmd);
	}
	public void printtext(String X,String Y,String VE,String he,String data)
	{
		String cmd = "FONT;NAME MSGBL.TTF\r\nTWOBYTE\r\nPOINT;"+Y+";"+X+";"+VE+";"+he+";*"+data+"*\r\nSTOP\r\n";//使用字体为MSGBL.TTF来打印中文，如打印内容中包含*，请修改data前后的*，变为内容中不会包含的符号
		//PTXLIBDLL.INSTANCE.sendcommand(cmd);
		byte[] data1 = new byte[1024];
    	try {
			data1=cmd.getBytes("UTF-8");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		PTXLIBDLL.INSTANCE.sendBinaryData(data1,data1.length);
	}
	public void printtexten(String X,String Y,String VE,String he,String data)
	{
		String cmd = "ALPHA\r\nPOINT;"+Y+";"+X+";"+VE+";"+he+";*"+data+"*\r\nSTOP\r\n";//仅可用来打印英文及数字，如打印内容中包含*，请修改data前后的*，变为内容中不会包含的符号
		//PTXLIBDLL.INSTANCE.sendcommand(cmd);
		byte[] data1 = new byte[1024];
    	try {
			data1=cmd.getBytes("UTF-8");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		PTXLIBDLL.INSTANCE.sendBinaryData(data1,data1.length);
	}
	public void printqrcode(String X,String Y,String witdh,String data)
	{
		
		String cmd = "BARCODE\r\nQRCODE;XD"+witdh+";"+Y+";"+X+"\r\n*"+data+"*\r\nSTOP\r\n";//打印QRCODE二维码，如打印内容中包含*，请修改data前后的*，变为内容中不会包含的符号
		byte[] data1 = new byte[1024];
    	try {
			data1=cmd.getBytes("UTF-8");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		PTXLIBDLL.INSTANCE.sendBinaryData(data1,data1.length);
	}
	public void printcode128(String X,String Y,int witdh,String data,Boolean read,double high)
	{
		if(read){
			String cmd="BARCODE\r\nC128A;XRD"+witdh*1+":"+witdh*1+":"+witdh*2+":"+witdh*2+":"+witdh*3+":"+witdh*3+":"+witdh*4+":"+witdh*4+";H"+high+";"+Y+";"+X+"\r\n*"+data+"*\r\nPDF\r\nSTOP\r\n";
			PTXLIBDLL.INSTANCE.sendcommand(cmd);
		}
		else{
			String cmd="BARCODE\r\nC128A;XRD"+witdh*1+":"+witdh*1+":"+witdh*2+":"+witdh*2+":"+witdh*3+":"+witdh*3+":"+witdh*4+":"+witdh*4+";H"+high+";"+Y+";"+X+"\r\n*"+data+"*\r\nSTOP\r\n";
			PTXLIBDLL.INSTANCE.sendcommand(cmd);
		}
		
	}
}
